/*
	᪮ 襭 "ᢥ姢㪮"   
	뢮 䨪 ⭮,   ᪮
	  t = 0.064 c. 砫 ࠧ  x = 50 .
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define k 1.4
#define R 287.1

double
	t1,
	p1 = 100000.,
	r1 = 1., a1,

	t4,
	p4 = 2000000.,
	r4 = 20., a4,

	x0 = 50.,
	t = 0.064,
	x;

double p2, M3, pi, u2, u3, a3;

	// 㭪樨 樮୮ ମ
double alfa__( double M ) { return 1 / ( 1 + 0.5*(k-1) * M ); }
double epsilon__( double M ) { return pow( 1 / ( 1 + 0.5*(k-1) * M ), 2/(k-1) ); }
double pi__( double M ) { return pow( 1 / ( 1 + 0.5*(k-1) * M ), 2*k/(k-1) ); }

/********
*  FUN  *
*********/
double Fun( double My )
{
	u2 = ( 2*a1 / (k+1) ) * ( My - 1/My );
	p2 = p1* ( 1 + (2*k/(k+1)) * (My*My-1) );
	pi = p2 / p4;
	M3 = (2/(k-1)) * ( 1/pow( pi, (k-1)/(2*k) ) -1 );
	a3 = a4 / ( 1 + ((k-1)/2) * M3 );
	u3 = a3 * M3;
	return u2 - u3;
} // end Fun()

/***********
 *  DIXOT  *         ⮤  
 ***********/
double Dixot( double a,   //  ࠭ १
			  double b,   // ࠢ ࠭ १
			  double epsilon )     // 筮 宦 
{
double c, fb;

	if( (Fun(a)) * (fb=Fun(b)) > 0. ) {
		printf("୮  ࠭ १");
		exit(1);
	}
	do {
		c = 0.5 * ( b + a );
		if( Fun(c) * fb >= 0. ) b = c;
		else a = c;
	} while( (b-a) > epsilon );
	return c;

} // end Dixot()

main()
{
int N = 15;
double dM, M, My, r, a, u, c, w, p;
FILE *pF;


	t1 = p1 / (R * r1);
	t4 = p4 / (R * r4);

	a1 = sqrt(k * R * t1);
	a4 = sqrt(k * R * t4);

	// 襭   ᯠ ࠧ뢠   
	My = Dixot(1.02, 4.0, 0.00000000001);
	printf("७ ࠢ = %1.10f\n\n", My );

	// 뢮 䨪 襭
	pF = fopen("input.dat", "w");
	//
	fprintf(pF, "%d\n3\n", 9+N );
	fprintf(pF, "0. %f %f 0. \n", r4 + 0.05*(r4-r1), p4 + 0.05*(p4-p1) );
	fprintf(pF, "0.000001 %f %f %f \n", r4, p4, 0. );
	//
	for (M = 0, dM = M3/N; M <= M3; M += dM) {
		a = a4 * alfa__( M );
		r = r4 * epsilon__( M );
		p = p4 * pi__( M );
		u = M * a;
		c = u - a;
		x = x0 + c * t;
		fprintf( pF, "%f %f %f %f \n", x, r, p, u );
	}
	printf("M3 = %f, u = %f \n", u/(c=sqrt(k * p /r)), u);
	fprintf( pF, "%f %f %f %f \n", x0 + u3*t, r, p, u3 );
	w = a1 * My;
	r = - r1 * w / ( u3 - w );

	//
	fprintf(pF, "%f %f %f %f \n", x0 + u3 * t + 0.000001, r, p, u3);
	fprintf(pF, "%f %f %f %f \n", x0 + w * t, r, p, u3);
	fprintf(pF, "%f %f %f %f \n", x0 + w * t + 0.000001, r1, p1, 0.);
	fprintf(pF, "%f %f %f %f \n", 2 * x0 - 0.000001, r1, p1, 0.);
	fprintf(pF, "%f %f %f %f \n", 2 * x0, 0., 0., 1.5*c);
	fclose(pF);
	
	return 0;

} // end main()

//--- end of "analyt.c" ---